#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include "fastclassifier.hh"
void
FastClassifier::length_checked_push(Packet *p)
{
  const unsigned *data = (const unsigned *)(p->data() - 0);
  int l = p->length();
  assert(l < 22);
 lstep_0:
  if (l < 14 || (data[3] & 65535U) != 1544U)
    goto lstep_3;
 lstep_1:
 lstep_2:
  output(3).push(p);
  return;
 lstep_3:
  if (l >= 14 && (data[3] & 65535U) == 8U) {
    output(2).push(p);
    return;
  }
  output(3).push(p);
  return;
}
inline void
FastClassifier::length_unchecked_push(Packet *p)
{
  const unsigned *data = (const unsigned *)(p->data() - 0);
 step_0:
  if ((data[3] & 65535U) != 1544U)
    goto step_3;
 step_1:
  if ((data[5] & 65535U) == 256U) {
    output(0).push(p);
    return;
  }
 step_2:
  if ((data[5] & 65535U) == 512U) {
    output(1).push(p);
    return;
  }
  output(3).push(p);
  return;
 step_3:
  if ((data[3] & 65535U) == 8U) {
    output(2).push(p);
    return;
  }
  output(3).push(p);
  return;
}
void
FastClassifier::push(int, Packet *p)
{
  if (p->length() < 22)
    length_checked_push(p);
  else
    length_unchecked_push(p);
}

EXPORT_ELEMENT(FastClassifier)
