/*
 * Copyright (c) 1999, 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Flux OSKit.  The OSKit is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Utah at csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The OSKit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the OSKit; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * A rather silly element that serves as a packet source that delivers
 * no packets.
 */

#ifndef FROMNULL_HH
#define FROMNULL_HH

#include "element.hh"
#include "string.hh"

class FromNull : public Element {
public:
	FromNull();
	~FromNull();
  
	const char *class_name() const		{ return "FromNull"; }
	const char *processing() const		{ return PUSH; }
  
	FromNull *clone() const;
	int configure(const String &, ErrorHandler *);
	int initialize(ErrorHandler *);

private:
	int	_ifnum;
};

#endif /* FROMNULL_HH */
