/*
 * Copyright (c) 1999, 2000 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Flux OSKit.  The OSKit is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Utah at csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The OSKit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the OSKit; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */

#ifdef __cplusplus
#define EXTERN extern "C"
#else
#define EXTERN extern
#endif

/*
 * Create and destroy from/to netio interfaces.
 */
EXTERN int
oskit_create_fromnetio(void *obj, int poll, int ifnum, void **priv);

EXTERN int
oskit_create_tonetio(void *obj, int ifnum, void **priv);

EXTERN int
oskit_destroy_fromnetio(int ifnum, void *priv);

EXTERN int
oskit_destroy_tonetio(int ifnum, void *priv);

/*
 * This is the push routine on the outgoing side. 
 */
EXTERN int
oskit_sendto_netio(void *obj, void *data, int len);

/*
 * Poll for packets.
 */
EXTERN int
oskit_netio_rx_poll(void *_priv, int *count, struct sk_buff *skbs[]);

/*
 * Another push routine that takes a bufio.
 */
EXTERN int
oskit_sendto_netio_withbufio(void *obj, struct sk_buff *skb, int len);

/*
 * This is the upcall from the netio code into FromNetIO.
 */
EXTERN int
click_FromNetio_in(void *obj, struct sk_buff *skb, int len);

