// ping.click

// Tests whether Click can read packets from the an Oskit netio, send
// them through the ICMPPing element, and back out through a netio.

// Basic Ping
//FromNetIO(0) ->
//	Print(ok) ->
//	ICMPPing() -> ToNetIO(0)

// If you want packet scheduling instead of responding from the bottom half
// (which is really an interrupt context in OSKit). The Queue causes packet
// processing to stop and schedule the PullToPush element to pick it up,
// and that is run out of the driver loop context not the interrupt context.
FromNetIO(0) ->
	Queue(200) -> PullToPush() ->
//	Print(ok) ->
	ICMPPing() -> ToNetIO(0);

// The Polling version.
//PollNetIO(0) ->
//	Print(ok) ->
//	ICMPPing() -> ToNetIO(0)

// A linux kernel device version.
//FromDevice(eth0) ->
//	Print(Ok) ->
//	ICMPPing() -> Queue(200) -> ToDevice(eth0)
